//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: em/authority/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Usage: instantiate `Em_Authority_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Em_Authority_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Em_Authority_V1_QueryClientInterceptorFactoryProtocol? { get }

  func gasPrices(
    _ request: Em_Authority_V1_QueryGasPricesRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Em_Authority_V1_QueryGasPricesRequest, Em_Authority_V1_QueryGasPricesResponse>

  func upgradePlan(
    _ request: Em_Authority_V1_QueryUpgradePlanRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Em_Authority_V1_QueryUpgradePlanRequest, Em_Authority_V1_QueryUpgradePlanResponse>
}

extension Em_Authority_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "em.authority.v1.Query"
  }

  /// Unary call to GasPrices
  ///
  /// - Parameters:
  ///   - request: Request to send to GasPrices.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func gasPrices(
    _ request: Em_Authority_V1_QueryGasPricesRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Em_Authority_V1_QueryGasPricesRequest, Em_Authority_V1_QueryGasPricesResponse> {
    return self.makeUnaryCall(
      path: "/em.authority.v1.Query/GasPrices",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGasPricesInterceptors() ?? []
    )
  }

  /// Unary call to UpgradePlan
  ///
  /// - Parameters:
  ///   - request: Request to send to UpgradePlan.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func upgradePlan(
    _ request: Em_Authority_V1_QueryUpgradePlanRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Em_Authority_V1_QueryUpgradePlanRequest, Em_Authority_V1_QueryUpgradePlanResponse> {
    return self.makeUnaryCall(
      path: "/em.authority.v1.Query/UpgradePlan",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUpgradePlanInterceptors() ?? []
    )
  }
}

internal protocol Em_Authority_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'gasPrices'.
  func makeGasPricesInterceptors() -> [ClientInterceptor<Em_Authority_V1_QueryGasPricesRequest, Em_Authority_V1_QueryGasPricesResponse>]

  /// - Returns: Interceptors to use when invoking 'upgradePlan'.
  func makeUpgradePlanInterceptors() -> [ClientInterceptor<Em_Authority_V1_QueryUpgradePlanRequest, Em_Authority_V1_QueryUpgradePlanResponse>]
}

internal final class Em_Authority_V1_QueryClient: Em_Authority_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Em_Authority_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the em.authority.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Em_Authority_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// To build a server, implement a class that conforms to this protocol.
internal protocol Em_Authority_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Em_Authority_V1_QueryServerInterceptorFactoryProtocol? { get }

  func gasPrices(request: Em_Authority_V1_QueryGasPricesRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Em_Authority_V1_QueryGasPricesResponse>

  func upgradePlan(request: Em_Authority_V1_QueryUpgradePlanRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Em_Authority_V1_QueryUpgradePlanResponse>
}

extension Em_Authority_V1_QueryProvider {
  internal var serviceName: Substring { return "em.authority.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "GasPrices":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Em_Authority_V1_QueryGasPricesRequest>(),
        responseSerializer: ProtobufSerializer<Em_Authority_V1_QueryGasPricesResponse>(),
        interceptors: self.interceptors?.makeGasPricesInterceptors() ?? [],
        userFunction: self.gasPrices(request:context:)
      )

    case "UpgradePlan":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Em_Authority_V1_QueryUpgradePlanRequest>(),
        responseSerializer: ProtobufSerializer<Em_Authority_V1_QueryUpgradePlanResponse>(),
        interceptors: self.interceptors?.makeUpgradePlanInterceptors() ?? [],
        userFunction: self.upgradePlan(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Em_Authority_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'gasPrices'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGasPricesInterceptors() -> [ServerInterceptor<Em_Authority_V1_QueryGasPricesRequest, Em_Authority_V1_QueryGasPricesResponse>]

  /// - Returns: Interceptors to use when handling 'upgradePlan'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUpgradePlanInterceptors() -> [ServerInterceptor<Em_Authority_V1_QueryUpgradePlanRequest, Em_Authority_V1_QueryUpgradePlanResponse>]
}
